//+------------------------------------------------------------------+
//|                                                  Custom MACD.mq4 |
//|                      Copyright  2004, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property  copyright "Copyright  2004, MetaQuotes Software Corp."
#property  link      "http://www.metaquotes.net/"
//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 3
#property  indicator_color1  Red
#property  indicator_color2  Yellow
#property  indicator_color3  Teal
#property  indicator_width1  2
#property  indicator_width2  1
#property  indicator_width3  1
//#property indicator_style2 2
#property indicator_level1 0.0004
#property indicator_level2 -0.0004
#property indicator_levelcolor  Maroon
//---- indicator parameters
extern int FastEMA=12;
extern int SlowEMA=26;
extern int SignalSMA=9;
//---- indicator buffers
double     MacdBuffer[];
double     SignalBuffer[];
double     DBuffer[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- drawing settings
   SetIndexStyle(2,DRAW_LINE);
   SetIndexStyle(1,DRAW_LINE);
      SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexDrawBegin(1,SignalSMA);
 //   SetIndexDrawBegin(2,DBuffer);
   IndicatorDigits(Digits+1);
//---- indicator buffers mapping
   SetIndexBuffer(2,MacdBuffer);
   SetIndexBuffer(1,SignalBuffer);
   SetIndexBuffer(0,DBuffer);

//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("MACDd("+FastEMA+","+SlowEMA+","+SignalSMA+")");
   SetIndexLabel(0,"MACD(f"+FastEMA+",sl"+SlowEMA+",sg"+SignalSMA+")");
   SetIndexLabel(1,"Signal(f"+FastEMA+",sl"+SlowEMA+",sg"+SignalSMA+")");
   SetIndexLabel(2,"MACDd(f"+FastEMA+",sl"+SlowEMA+",sg"+SignalSMA+")");

//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Moving Averages Convergence/Divergence                           |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   int counted_bars=IndicatorCounted();
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
//---- macd counted in the 1-st buffer
   for(int i=0; i<limit; i++)
      MacdBuffer[i]=iMA(NULL,0,FastEMA,0,MODE_EMA,PRICE_CLOSE,i)-iMA(NULL,0,SlowEMA,0,MODE_EMA,PRICE_CLOSE,i);
//---- signal line counted in the 2-nd buffer
   for(i=0; i<limit; i++)
      SignalBuffer[i]=iMAOnArray(MacdBuffer,Bars,SignalSMA,0,MODE_SMA,i);
   for(i=0; i<limit; i++)
      DBuffer[i]= (MacdBuffer[i] - MacdBuffer[i+1])*5;

//---- done
   return(0);
  }
//+------------------------------------------------------------------+